//  Demo 5: MovingSquare.java
//
//     A Simple Java Application to Use the Square Class
//
//             by Charles W. Neville
//      Copyright Charles W. Neville, July, 1999
//
// A Square moving diagonally across the screen.
// Illustrates simple animation and a use of the Square class.

// Note: The animation here is rather crude.  For one thing, it
//       flickers alot.  In the next demo, we will see how to
//       animate smoothly using Graphics double buffering.
//       Also, the user can't stop this until the animation is
//       finished.  We will shortly see how to avoid this problem
//       by using a separate Thread of execution (multi-tasking) 
//       for the animation.

import java.awt.*;
import Square;
import CloseAndExit;

public class MovingSquare extends Frame {

   Square s;  // our Square

   // Constructor: simply initializes the variable s and registers
   //              an instance of CloseAndExit as a window event
   //              listener
   public MovingSquare() {

      s = new Square(50, 50, 25, Color.red);  // initialize object
                                              // state variable s

     addWindowListener(new CloseAndExit());

   } // Constructor MovingSquare()

   public void paint(Graphics g) {

     Color backgroundColor = getBackground();

     // Here comes the animation!
     for(int i = 1; i <= 200; i++) {

        // Note: use of methods of Square class
        s.draw(g, backgroundColor);  // hide square
        s.move(1, 1);
        s.draw(g);

        // To pause, so the animation doesn't go too fast, use
        // the sleep() method of the Thread class.  Unfortunately,
        // it throws an InterruptedException, so we have to embed
        // our simple pause statement in a try -- catch clause.
        try {
          Thread.sleep(20);  // 20 ms pause
        }
        catch (InterruptedException e) {
          // do nothing
        }
     }
   } // paint

   public static void main(String[] args) {

     MovingSquare ms = new MovingSquare();

     ms.setSize(400, 400);
     ms.setVisible(true);

   } // main()

} // class MovingSquare
        
